function StatsLink(offsetsArray) {
	this.offsets = offsetsArray;
	this.statsPerValue = {};
	// adds the maxima for a certain value
	this.add = function(value, statValues) {
		this.statsPerValue[value] = statValues;
		return this;
	}
}

function CharacterStats(size) {
	this.size = size;

	function ValueMax(value, max) {
		this.value = value;
		this.max = max;
		this.valueNode = undefined;
		this.maxNode = undefined;
		
		this.setValue = function(v) {
			this.value = v;
			this.valueNode.value = this.value;
			var event = new Event('input');
			this.valueNode.dispatchEvent(event);
		}
		
		this.setMax = function(max_v) {
			this.max = max_v;
			this.maxNode.value = this.max;
			var event = new Event('input');
			this.maxNode.dispatchEvent(event);
		}
	}
	
	function OffsetMax(name, valueOffset, maxOffset) {
		this.name = name;
		this.valueOffset = valueOffset;
		this.maxOffset = maxOffset;
		this.byteLength = 1;
	}
	
	function Value(value) {
		this.value = value;
	}

	function Offset(name, valueOffset, byteLength) {
		this.name = name;
		this.valueOffset = valueOffset;
		this.byteLength = byteLength;
	}
	
	function OffsetEnum(name, valueOffset, valueDict) {
		this.name = name;
		this.valueOffset = valueOffset;
		this.byteLength = 1;
		this.enumValueDict = valueDict;
		this.enumNameDict = {};
		Object.entries(this.enumValueDict).forEach(entry => {
		  const [key, value] = entry;
		  this.enumNameDict[value] = key;
		});
		
		this.link = undefined;
		
		this.addLink = function(statsLink) {
			this.link = statsLink;
			return this;
		}
	}

	this.attributeOffsets = [
		new OffsetMax("STRength", 0x187, 0x19B),
		new OffsetMax("INTelligence", 0x189, 0x19D),
		new OffsetMax("DEXterity", 0x18B, 0x19F),
		new OffsetMax("SPEed", 0x18D, 0x1A1),
		new OffsetMax("CONstitution", 0x18F, 0x1A3),
		new OffsetMax("CHArisma", 0x191, 0x1A5),
		new OffsetMax("LUCk", 0x193, 0x1A7),
		new OffsetMax("MAGic Resist.", 0x195, 0x1A9),
		new OffsetMax("AGE", 0x197, 0x1AB)
	];
	this.abilityOffsets = [
		new OffsetMax("ATTack", 0x144, 0x14E),
		new OffsetMax("PARry", 0x145, 0x14F),
		new OffsetMax("SWImming", 0x146, 0x150),
		new OffsetMax("LIStening", 0x147, 0x151),
		new OffsetMax("Finding traps", 0x148, 0x152),
		new OffsetMax("Disarming traps", 0x149, 0x153),
		new OffsetMax("Picking locks", 0x14A, 0x154),
		new OffsetMax("SEArching", 0x14B, 0x155),
		new OffsetMax("Read magic scr", 0x14C, 0x156),
		new OffsetMax("Use magic", 0x14D, 0x157)
	];
	this.suppliesOffsets = [
		new Offset("Gold", 0x1CF, 1),
		new Offset("Rations", 0x1D1, 1),
		new OffsetMax("Life Points", 0x1C5, 0x1C7),
		new Offset("Experience", 0x20C, 2),
		new OffsetMax("SP", 0x1C9, 0x1CB),
		new OffsetMax("SLP", 0x1CD, 0x1CF)
	];
	var attributeLink = new StatsLink(this.attributeOffsets);
	var abilityLink = new StatsLink(this.abilityOffsets);
	this.appearanceOffsets = [
		new OffsetEnum("Character Class", 0x143, { 0: "None", 1: "Warrior", 2: "Paladine", 3: "Ranger", 4: "Thief", 5: "Monk", 6: "White Wizard", 7: "Gray Wizard", 8: "Black Wizard", 9: "Special", 0xA: "Monster"}).addLink(abilityLink),
		new OffsetEnum("Race", 0x142, { 0: "Human", 1: "Elf", 2: "Dwarf", 3: "Gnome", 4: "Halfling", 5: "Half-elf", 6: "Half-ork", 0x0D: "Pet", 0x0E: "Beast" }).addLink(attributeLink),
		new OffsetEnum("Sex", 0x141, { 0: "Male", 1: "Female"}),
	];
	
	// Attribute maxima for Race
	attributeLink.add(0, [60,60,60,60,60,60,100,0,80]);
	attributeLink.add(1, [30,100,70,80,30,90,100,20,950]);
	attributeLink.add(2, [90,30,20,30,100,40,100,100,600]);
	attributeLink.add(3, [40,70,80,50,40,80,100,80,350]);
	attributeLink.add(4, [20,40,100,100,20,130,100,20,250]);
	attributeLink.add(5, [45,80,65,70,30,30,100,10,200]);
	attributeLink.add(6, [80,20,50,40,80,20,100,0,50]);
	attributeLink.add(0x0D, [99,100,100,100,100,100,100,100,231]);
	attributeLink.add(0x0E, [99,100,100,100,100,100,100,100,231]);
	// Ability maxima for Class
	abilityLink.add(0, [20,20,95,5,0,0,0,5,0,0]);
	abilityLink.add(1, [95,80,95,50,20,10,15,20,0,0]);
	abilityLink.add(2, [80,95,95,50,30,10,0,10,70,50]);
	abilityLink.add(3, [70,70,95,80,40,40,40,30,30,30]);
	abilityLink.add(4, [50,50,95,95,95,95,95,95,0,0]);
	abilityLink.add(5, [60,60,95,60,40,30,35,70,50,60]);
	abilityLink.add(6, [20,20,95,20,15,15,0,50,95,95]);
	abilityLink.add(7, [30,30,95,20,10,10,0,50,95,95]);
	abilityLink.add(8, [40,40,95,20,0,0,0,50,95,95]);
	abilityLink.add(9, [99,99,99,99,99,99,99,99,99,99]);
	abilityLink.add(0xA, [99,99,99,99,99,99,99,99,99,99]);
	
	this.characterImage = undefined;
		
	function readArray(offsetArray, contents, contentOffset) {
		offsetArray.forEach(offset => {
			if (offset.maxOffset != undefined) {
				var value = contents.getUint8(contentOffset + offset.valueOffset);
				var max = contents.getUint8(contentOffset + offset.maxOffset);
				offset.value = new ValueMax(value, max);
			} else {
				if (offset.byteLength == 1) {
					var value = contents.getUint8(contentOffset + offset.valueOffset);
				} else if (offset.byteLength == 2) {
					var value = contents.getUint16(contentOffset + offset.valueOffset);
				}
				offset.value = new Value(value);
			}
		});
	}
		
	this.read = function(contents, contentOffset) {
		readArray(this.attributeOffsets, contents, contentOffset);
		readArray(this.abilityOffsets, contents, contentOffset);
		readArray(this.suppliesOffsets, contents, contentOffset);
		readArray(this.appearanceOffsets, contents, contentOffset);
		this.characterImage = new PaletteImage();
		this.characterImage.loadFromAmberCharFile(contents, contentOffset, this.size);
		this.characterImage.paintCanvas();
	}
		
	function writeArray(offsetArray, contents, contentOffset) {
		offsetArray.forEach(offset => {
			if (offset.maxOffset != undefined) {
				var max = parseInt(offset.value.max);
				var value = parseInt(offset.value.value);
				//Cannot enforce maximum because some predefined characters go beyond it
				//value = Math.min(value, max);
				contents.setUint8(contentOffset + offset.valueOffset, value);
				contents.setUint8(contentOffset + offset.maxOffset, max);
			} else {
				if (offset.byteLength == 1) {
					contents.setUint8(contentOffset + offset.valueOffset, offset.value.value);
				} else if (offset.byteLength == 2) {
					contents.setUint16(contentOffset + offset.valueOffset, offset.value.value);
				}
			}
		});
	}
	
	this.write = function(contents, contentOffset, characterIndex) {
		writeArray(this.attributeOffsets, contents, contentOffset);
		writeArray(this.abilityOffsets, contents, contentOffset);
		writeArray(this.suppliesOffsets, contents, contentOffset);
		writeArray(this.appearanceOffsets, contents, contentOffset);
		if (this.characterImage.isValidImage()) {
			this.characterImage.writeToAmberCharFile(contents, contentOffset, this.characterImage.imageContent);
		}
	}
}


function AmberstarCharacter(size, hero) {
  this.size = size;
  this.hero = hero;
  this.name = "";
  this.stats = new CharacterStats(size);
  this.items = new CharacterItems(this);
}

function NameDecoder() {
	// Requires special code page for name
	this.decoder = new TextDecoder("utf-8");
	this.encoder = new TextEncoder("utf-8");
	this.codepage = {
		  27: "←" // Rune C
		, 32: " ", 33: "!", 34: '"', 35: "#", 36: "$", 37: "%"
		, 39: "'", 40: "(", 41: ")", 42: "*", 43: "+", 44: ",", 45: "-", 46: ".", 47: "/"
		, 48: "0", 49: "1", 50: "2", 51: "3", 52: "4", 53: "5", 54: "6", 55: "7", 56: "8", 57: "9", 58: ":", 59: ";"
		, 61: "=", 63: "?"
		, 65: "A", 66: "B", 67: "C", 68: "D", 69: "E", 70: "F", 71: "G", 72: "H", 73: "I", 74: "J", 75: "K", 76: "L", 77: "M", 78: "N", 79: "O"
		, 80: "P", 81: "Q", 82: "R", 83: "S", 84: "T", 85: "U", 86: "V", 87: "W", 88: "X", 89: "Y", 90: "Z"
		, 95: "_", 97: "a", 98: "b", 99: "c", 100: "d", 101: "e", 102: "f", 103: "g", 104: "h", 105: "i", 106: "j", 107: "k", 108: "l", 109: "m", 110: "n", 111: "o"
		, 112: "p", 113: "q", 114: "r", 115: "s", 116: "t", 117: "u", 118: "v", 119: "w", 120: "x", 121: "y", 122: "z", 126: "~" // Switches to Rune alphabet. Use second ~ to switch back. Don't use for first 5 chars
		, 0x81: "ü", 0x84: "ä", 0x8E: "Ä"
		, 0x94: "ö", 0x99: "Ö", 0x9A: "Ü", 0x9E: "ß"
	}
	this.codepagereverse = {};
	Object.entries(this.codepage).forEach(entry => {
	  const [key, value] = entry;
	  this.codepagereverse[value] = key;
	});
	this.predecode = function (uint8array) {
		var newchars = [];
		for (var index = 0; index < uint8array.length; ++index) {
			var utf_chars = this.encoder.encode(this.codepage[uint8array[index]]);
			if (utf_chars !== undefined) {
				for (var utf_index = 0; utf_index < utf_chars.length; ++utf_index) {
					newchars.push(utf_chars[utf_index]);
				}
			}
		}
		return newchars;
	}
	this.decode = function(uint8array) {
		var predecoded = this.predecode(uint8array);
		return this.decoder.decode(new Uint8Array(predecoded));
	}
	this.encode = function(text) {
		var newbytes = [];
		for (var index = 0; index < text.length; ++index) {
			var value = this.codepagereverse[text[index]];
			if (value !== undefined) {
				newbytes.push(value);
			}
		}
		return newbytes;
	}
}

function getHeroIndexes() {
	// The hero indexes
	return [
		0, // Own character
		13, // Torg
		65, // Drobanir
		11, // Silk
		61, // Satine
		24, // Trasric
		23, // Gryban
		60, // Crag
		64, // Boldin
		39, // Sheba
		33, // Melchior
		7, // Spike
		51, // Shir'kar
	];
}